<?php
namespace Thombo\Sishandball2\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Thomas Bodenbender <info@thombo.com>
 *  thombo Softwareentwicklung und IT-Beratungs GmbH
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class Crosstable {

	protected $storage;

	public function createCrosstable(\TYPO3\CMS\Extbase\Persistence\Generic\QueryResult $matches, \TYPO3\CMS\Extbase\Persistence\Generic\QueryResult $teams) {
		foreach($teams as $team) {
			$this->storage[$team->getUid()] = array();
			$this->storage[$team->getUid()]['team'] = $team->getUid();
			$this->storage[$team->getUid()]['results'] = array();
			$this->storage[$team->getUid()]['results'][$team->getUid] = '--';
		}

		foreach($matches as $match) {
			if($match->getPtsH() != 0 || $match->getPtsG() != 0) {
				$this->storage[$match->getHome()->getUid()]['results'][$match->getGuest()->getUid()]['isResult'] = TRUE;
				$this->storage[$match->getHome()->getUid()]['results'][$match->getGuest()->getUid()]['content'] = $match->getRsltH().':'.$match->getRsltG();
			} else {
				$this->storage[$match->getHome()->getUid()]['results'][$match->getGuest()->getUid()]['isResult'] = FALSE;
				$this->storage[$match->getHome()->getUid()]['results'][$match->getGuest()->getUid()]['content'] = $match->getMatchdate();
			}
		}
	}

	public function getMatch(\TYPO3\CMS\Extbase\Persistence\Generic\QueryResult $home, \TYPO3\CMS\Extbase\Persistence\Generic\QueryResult $guest) {
		return $this->storage[$home->getUid()]['results'][$guest->getUid()];
	}

}

?>