<?php
namespace Thombo\Sishandball2\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Thomas Bodenbender <info@thombo.com>, thombo Softwareentwicklung und IT-Beratungs GmbH
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class Match extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * number
	 *
	 * @var \string
	 */
	protected $number;

	/**
	 * matchdate
	 *
	 * @var \DateTime
	 */
	protected $matchdate;

	/**
	 * rsltHlfH
	 *
	 * @var \integer
	 */
	protected $rsltHlfH;

	/**
	 * rsltHlfG
	 *
	 * @var \integer
	 */
	protected $rsltHlfG;

	/**
	 * rsltH
	 *
	 * @var \integer
	 */
	protected $rsltH;

	/**
	 * rsltG
	 *
	 * @var \integer
	 */
	protected $rsltG;

	/**
	 * ptsH
	 *
	 * @var \integer
	 */
	protected $ptsH;

	/**
	 * ptsG
	 *
	 * @var \integer
	 */
	protected $ptsG;

	/**
	 * reports
	 *
	 * @var \string
	 */
	protected $reports;

	/**
	 * smscode
	 *
	 * @var \string
	 */
	protected $smscode;

	/**
	 * league
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\League
	 */
	protected $league;

	/**
	 * home
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\Team
	 */
	protected $home;

	/**
	 * guest
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\Team
	 */
	protected $guest;

	/**
	 * hall
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\Sportshall
	 */
	protected $hall;

	/**
	 * Returns the number
	 *
	 * @return \string $number
	 */
	public function getNumber() {
		return $this->number;
	}

	/**
	 * Sets the number
	 *
	 * @param \string $number
	 * @return void
	 */
	public function setNumber($number) {
		$this->number = $number;
	}

	/**
	 * Returns the matchdate
	 *
	 * @return \DateTime $matchdate
	 */
	public function getMatchdate() {
		return $this->matchdate;
	}

	/**
	 * Sets the matchdate
	 *
	 * @param \DateTime $matchdate
	 * @return void
	 */
	public function setMatchdate($matchdate) {
		$this->matchdate = $matchdate;
	}

	/**
	 * Returns the rsltHlfH
	 *
	 * @return \integer $rsltHlfH
	 */
	public function getRsltHlfH() {
		return $this->rsltHlfH;
	}

	/**
	 * Sets the rsltHlfH
	 *
	 * @param \integer $rsltHlfH
	 * @return void
	 */
	public function setRsltHlfH($rsltHlfH) {
		$this->rsltHlfH = $rsltHlfH;
	}

	/**
	 * Returns the rsltHlfG
	 *
	 * @return \integer $rsltHlfG
	 */
	public function getRsltHlfG() {
		return $this->rsltHlfG;
	}

	/**
	 * Sets the rsltHlfG
	 *
	 * @param \integer $rsltHlfG
	 * @return void
	 */
	public function setRsltHlfG($rsltHlfG) {
		$this->rsltHlfG = $rsltHlfG;
	}

	/**
	 * Returns the rsltH
	 *
	 * @return \integer $rsltH
	 */
	public function getRsltH() {
		return $this->rsltH;
	}

	/**
	 * Sets the rsltH
	 *
	 * @param \integer $rsltH
	 * @return void
	 */
	public function setRsltH($rsltH) {
		$this->rsltH = $rsltH;
	}

	/**
	 * Returns the rsltG
	 *
	 * @return \integer $rsltG
	 */
	public function getRsltG() {
		return $this->rsltG;
	}

	/**
	 * Sets the rsltG
	 *
	 * @param \integer $rsltG
	 * @return void
	 */
	public function setRsltG($rsltG) {
		$this->rsltG = $rsltG;
	}

	/**
	 * Returns the ptsH
	 *
	 * @return \integer $ptsH
	 */
	public function getPtsH() {
		return $this->ptsH;
	}

	/**
	 * Sets the ptsH
	 *
	 * @param \integer $ptsH
	 * @return void
	 */
	public function setPtsH($ptsH) {
		$this->ptsH = $ptsH;
	}

	/**
	 * Returns the ptsG
	 *
	 * @return \integer $ptsG
	 */
	public function getPtsG() {
		return $this->ptsG;
	}

	/**
	 * Sets the ptsG
	 *
	 * @param \integer $ptsG
	 * @return void
	 */
	public function setPtsG($ptsG) {
		$this->ptsG = $ptsG;
	}

	/**
	 * Returns the reports
	 *
	 * @return \string $reports
	 */
	public function getReports() {
		return $this->reports;
	}

	/**
	 * Sets the reports
	 *
	 * @param \string $reports
	 * @return void
	 */
	public function setReports($reports) {
		$this->reports = $reports;
	}

	/**
	 * Returns the smscode
	 *
	 * @return \string $smscode
	 */
	public function getSmscode() {
		return $this->smscode;
	}

	/**
	 * Sets the smscode
	 *
	 * @param \string $smscode
	 * @return void
	 */
	public function setSmscode($smscode) {
		$this->smscode = $smscode;
	}

	/**
	 * Returns the league
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\League $league
	 */
	public function getLeague() {
		return $this->league;
	}

	/**
	 * Sets the league
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\League $league
	 * @return void
	 */
	public function setLeague(\Thombo\Sishandball2\Domain\Model\League $league) {
		$this->league = $league;
	}

	/**
	 * Returns the home
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\Team $home
	 */
	public function getHome() {
		return $this->home;
	}

	/**
	 * Sets the home
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\Team $home
	 * @return void
	 */
	public function setHome(\Thombo\Sishandball2\Domain\Model\Team $home) {
		$this->home = $home;
	}

	/**
	 * Returns the guest
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\Team $guest
	 */
	public function getGuest() {
		return $this->guest;
	}

	/**
	 * Sets the guest
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\Team $guest
	 * @return void
	 */
	public function setGuest(\Thombo\Sishandball2\Domain\Model\Team $guest) {
		$this->guest = $guest;
	}

	/**
	 * Returns the hall
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\Sportshall $hall
	 */
	public function getHall() {
		return $this->hall;
	}

	/**
	 * Sets the hall
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\Sportshall $hall
	 * @return void
	 */
	public function setHall(\Thombo\Sishandball2\Domain\Model\Sportshall $hall) {
		$this->hall = $hall;
	}

}
?>