<?php
namespace Thombo\Sishandball2\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Thomas Bodenbender <info@thombo.com>, thombo Softwareentwicklung und IT-Beratungs GmbH
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class Matchday extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * matches
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Thombo\Sishandball2\Domain\Model\Match>
	 */
	protected $matches;

	/**
	 * actmatchday
	 *
	 * @var boolean
	 */
	protected $actmatchday = FALSE;

	/**
	 * __construct
	 *
	 * @return Matchday
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties.
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		/**
		 * Do not modify this method!
		 * It will be rewritten on each save in the extension builder
		 * You may modify the constructor of this class instead
		 */
		$this->matches = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

	/**
	 * Adds a Match
	 *
	 * @param \Thombo\Sishandball3\Domain\Model\Match $match
	 * @return void
	 */
	public function addMatch(\Thombo\Sishandball2\Domain\Model\Match $match) {
		$this->matches->attach($match);
	}

	/**
	 * Removes a Match
	 *
	 * @param \Thombo\Sishandball3\Domain\Model\Match $matchToRemove The Match to be removed
	 * @return void
	 */
	public function removeMatch(\Thombo\Sishandball2\Domain\Model\Match $matchToRemove) {
		$this->matches->detach($matchToRemove);
	}

	/**
	 * Returns the matches
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Thombo\Sishandball3\Domain\Model\Match> $matches
	 */
	public function getMatches() {
		return $this->matches;
	}

	/**
	 * Sets the matches
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Thombo\Sishandball3\Domain\Model\Match> $matches
	 * @return void
	 */
	public function setMatches(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $matches) {
		$this->matches = $matches;
	}

	/**
	 * Returns the actmatchday
	 *
	 * @return boolean $actmatchday
	 */
	public function getActmatchday() {
		return $this->actmatchday;
	}

	/**
	 * Sets the actmatchday
	 *
	 * @param boolean $actmatchday
	 * @return void
	 */
	public function setActmatchday($actmatchday) {
		$this->actmatchday = $actmatchday;
	}

	/**
	 * Returns the boolean state of actmatchday
	 *
	 * @return boolean
	 */
	public function isActmatchday() {
		return $this->getActmatchday();
	}

}
?>