<?php
namespace Thombo\Sishandball2\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Thomas Bodenbender <info@thombo.com>, thombo Softwareentwicklung und IT-Beratungs GmbH
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class SpecialTeamShort extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * shortdescription
	 *
	 * @var \string
	 */
	protected $shortdescription;

	/**
	 * league
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\League
	 */
	protected $league;

	/**
	 * team
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\Team
	 */
	protected $team;

	/**
	 * Returns the shortdescription
	 *
	 * @return \string $shortdescription
	 */
	public function getShortdescription() {
		return $this->shortdescription;
	}

	/**
	 * Sets the shortdescription
	 *
	 * @param \string $shortdescription
	 * @return void
	 */
	public function setShortdescription($shortdescription) {
		$this->shortdescription = $shortdescription;
	}

	/**
	 * Returns the league
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\League $league
	 */
	public function getLeague() {
		return $this->league;
	}

	/**
	 * Sets the league
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\League $league
	 * @return void
	 */
	public function setLeague(\Thombo\Sishandball2\Domain\Model\League $league) {
		$this->league = $league;
	}

	/**
	 * Returns the team
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\Team $team
	 */
	public function getTeam() {
		return $this->team;
	}

	/**
	 * Sets the team
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\Team $team
	 * @return void
	 */
	public function setTeam(\Thombo\Sishandball2\Domain\Model\Team $team) {
		$this->team = $team;
	}

}
?>