<?php
namespace Thombo\Sishandball2\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Thomas Bodenbender <info@thombo.com>, thombo Softwareentwicklung und IT-Beratungs GmbH
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class Team extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * number
	 *
	 * @var \string
	 */
	protected $number;

	/**
	 * name
	 *
	 * @var \string
	 */
	protected $name;

	/**
	 * sisname
	 *
	 * @var \string
	 */
	protected $sisname;

	/**
	 * withoutscoring
	 *
	 * @var boolean
	 */
	protected $withoutscoring = FALSE;

	/**
	 * withdrawed
	 *
	 * @var boolean
	 */
	protected $withdrawed = FALSE;

	/**
	 * link
	 *
	 * @var \string
	 */
	protected $link;

	/**
	 * club
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\Club
	 */
	protected $club;

	/**
	 * league
	 *
	 * @var \Thombo\Sishandball2\Domain\Model\League
	 */
	protected $league;

	/**
	 * Returns the number
	 *
	 * @return \string $number
	 */
	public function getNumber() {
		return $this->number;
	}

	/**
	 * Sets the number
	 *
	 * @param \string $number
	 * @return void
	 */
	public function setNumber($number) {
		$this->number = $number;
	}

	/**
	 * Returns the name
	 *
	 * @return \string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param \string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

	/**
	 * Returns the sisname
	 *
	 * @return \string $sisname
	 */
	public function getSisname() {
		return $this->sisname;
	}

	/**
	 * Sets the sisname
	 *
	 * @param \string $sisname
	 * @return void
	 */
	public function setSisname($sisname) {
		$this->sisname = $sisname;
	}

	/**
	 * Returns the withoutscoring
	 *
	 * @return boolean $withoutscoring
	 */
	public function getWithoutscoring() {
		return $this->withoutscoring;
	}

	/**
	 * Sets the withoutscoring
	 *
	 * @param boolean $withoutscoring
	 * @return void
	 */
	public function setWithoutscoring($withoutscoring) {
		$this->withoutscoring = $withoutscoring;
	}

	/**
	 * Returns the boolean state of withoutscoring
	 *
	 * @return boolean
	 */
	public function isWithoutscoring() {
		return $this->getWithoutscoring();
	}

	/**
	 * Returns the withdrawed
	 *
	 * @return boolean $withdrawed
	 */
	public function getWithdrawed() {
		return $this->withdrawed;
	}

	/**
	 * Sets the withdrawed
	 *
	 * @param boolean $withdrawed
	 * @return void
	 */
	public function setWithdrawed($withdrawed) {
		$this->withdrawed = $withdrawed;
	}

	/**
	 * Returns the boolean state of withdrawed
	 *
	 * @return boolean
	 */
	public function isWithdrawed() {
		return $this->getWithdrawed();
	}

	/**
	 * Returns the link
	 *
	 * @return \string $link
	 */
	public function getLink() {
		return $this->link;
	}

	/**
	 * Sets the link
	 *
	 * @param \string $link
	 * @return void
	 */
	public function setLink($link) {
		$this->link = $link;
	}

	/**
	 * Returns the club
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\Club $club
	 */
	public function getClub() {
		return $this->club;
	}

	/**
	 * Sets the club
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\Club $club
	 * @return void
	 */
	public function setClub(\Thombo\Sishandball2\Domain\Model\Club $club) {
		$this->club = $club;
	}

	/**
	 * Returns the league
	 *
	 * @return \Thombo\Sishandball2\Domain\Model\League $league
	 */
	public function getLeague() {
		return $this->league;
	}

	/**
	 * Sets the league
	 *
	 * @param \Thombo\Sishandball2\Domain\Model\League $league
	 * @return void
	 */
	public function setLeague(\Thombo\Sishandball2\Domain\Model\League $league) {
		$this->league = $league;
	}

}
?>