<?php
namespace Thombo\Sishandball2\Helper;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 Thomas Bodenbender <info@thombo.com>
 *  thombo Softwareentwicklung und IT-Beratungs GmbH
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
class BEView {

	/**
	 * Function called from TV, used to generate preview of this plugin
	 *
	 * @param  array   $row:        tt_content table row
	 * @param  string  $table:      usually tt_content
	 * @param  bool    $alreadyRendered:  To let TV know we have successfully rendered a preview
	 * @param object   $reference tx_templavoila_module1
	 * @return string  $content
	 */
	public function renderPreviewContent_preProcess ($aRowData, $sTable, &$alreadyRendered, &$objReference) {
		if ($aRowData['CType'] === 'list' && $aRowData['list_type'] === 'sishandball2_sishandball2') {
			$htmlContent = $this->getPreviewSimple($aRowData);
			$alreadyRendered = TRUE;
			return $objReference->link_edit($htmlContent,$sTable,$aRowData['uid']);
		}
	}

	/**
	 * Function called from page view, used to generate preview of this plugin
	 *
	 * @param  array   $params:  flexform params
	 * @param  array   $pObj:    parent object
	 * @return string  $result:  the hghlighted text
	 */
	public function getExtensionSummary($params, &$pObj) {
		$content = $this->getPreviewSimple($params['row']);
		return $pObj->linkEditContent($content, $params['row']);
	}

	/**
	 * Render the preview in a more simple way
	 *
	 * @param array  $row tt_content row of the plugin
	 * @return string rendered preview html
	 */
	protected function getPreviewSimple($row) {
		$content = '';
		$aRowData = \TYPO3\CMS\Core\Utility\GeneralUtility::xml2array($row['pi_flexform']);
		if(is_array($aRowData) && !empty($aRowData['data']['sDEF']['lDEF']['switchableControllerActions']['vDEF'])) {
			$content .= '<strong>'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.beviewtopic').'</strong><br />';
			switch($aRowData['data']['sDEF']['lDEF']['switchableControllerActions']['vDEF']) {
				case 'Match->matches4Team':
					$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.teammatches');

					$htmlTmpContent = '';
					$bDataOK = FALSE;
					if(!empty($aRowData['data']['sDEF']['lDEF']['settings.teammatches.displaySelection']['vDEF'])) {
						switch($aRowData['data']['sDEF']['lDEF']['settings.teammatches.displaySelection']['vDEF']) {
							case TEAMMATCHES_DISPLAYTHEWHOLEPROGRAM:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.altogether').' - ';
								break;

							case TEAMMATCHES_DISPLAYTHENEXT:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.onlynextone').' - ';
								break;

							case TEAMMATCHES_DISPLAYACT:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.actualmatch').' -- ';
								break;

							case TEAMMATCHES_DISPLAYLASTONE:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.lastmatch').' -- ';
								break;
						}

						if(!empty($aRowData['data']['sDEF']['lDEF']['settings.teammatches.teamSelection']['vDEF'])) {
							$aTeamdata = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('name','tx_sishandball2_domain_model_team','uid = '.intval($aRowData['data']['sDEF']['lDEF']['settings.teammatches.teamSelection']['vDEF']));
							if(!empty($aTeamdata['name'])) {
								$htmlTmpContent .= $aTeamdata['name'];
								if(!empty($aRowData['data']['sDEF']['lDEF']['settings.teammatches.leagueSelection']['vDEF'])) {
									$aLeaguedata = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('name','tx_sishandball2_domain_model_league','uid = '.intval($aRowData['data']['sDEF']['lDEF']['settings.teammatches.leagueSelection']['vDEF']));
									if(!empty($aLeaguedata['name'])) {
										$htmlTmpContent .= ' ('.$aLeaguedata['name'].')';
										$bDataOK = TRUE;
									}
								}
							}
						}
					}

					if(!$bDataOK) {
						$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.beview.unvalid');
					} else {
						$content .= $htmlTmpContent;
					}
					break;

				case 'Match->matches4League':
					$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.leaguematches');

					$htmlTmpContent = '';
					$bDataOK = FALSE;
					if(!empty($aRowData['data']['sDEF']['lDEF']['settings.leaguematches.displaySelection']['vDEF'])) {
						switch($aRowData['data']['sDEF']['lDEF']['settings.leaguematches.displaySelection']['vDEF']) {
							case LEAGUEMATCHES_DISPLAYTHEWHOLEPROGRAM:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.altogether').' - ';
								break;

							case LEAGUEMATCHES_DISPLAYRELATIVEWEEKEND:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.onlyoneweekend_relative_short').' - ';
								break;

							case LEAGUEMATCHES_DISPLAYABSOLUTEWEEKEND:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.onlyoneweekend_absolute_short').' - ';
								break;
						}

						if(!empty($aRowData['data']['sDEF']['lDEF']['settings.leaguematches.leagueSelection']['vDEF'])) {
							$aTeamdata = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('name','tx_sishandball2_domain_model_league','uid = '.intval($aRowData['data']['sDEF']['lDEF']['settings.leaguematches.leagueSelection']['vDEF']));
							if(!empty($aTeamdata['name'])) {
								$htmlTmpContent .= $aTeamdata['name'];
								$bDataOK = TRUE;
							}
						}
					}

					if(!$bDataOK) {
						$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.beview.unvalid');
					} else {
						$content .= $htmlTmpContent;
					}
					break;

				case 'Match->matches4club':
					$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.clubmatches');

					$htmlTmpContent = '';
					$bDataOK = FALSE;
					if(!empty($aRowData['data']['sDEF']['lDEF']['settings.clubmatches.displayselection']['vDEF'])) {
						switch($aRowData['data']['sDEF']['lDEF']['settings.clubmatches.displayselection']['vDEF']) {
							case CLUBMATCHES_DISPLAYTHEWHOLEPROGRAM:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.altogether').' - ';
								break;

							case CLUBMATCHES_DISPLAYRELATIVEWEEKEND:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.onlyoneweekend_relative_short').' - ';
								break;

							case CLUBMATCHES_DISPLAYABSOLUTEWEEKEND:
								$htmlTmpContent .= ' - '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.onlyoneweekend_absolute_short').' - ';
								break;
						}

						if(!empty($aRowData['data']['sDEF']['lDEF']['settings.clubmatches.clubSelection']['vDEF'])) {
							$aTeamdata = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('name','tx_sishandball2_domain_model_club','uid = '.intval($aRowData['data']['sDEF']['lDEF']['settings.clubmatches.clubSelection']['vDEF']));
							if(!empty($aTeamdata['name'])) {
								$htmlTmpContent .= $aTeamdata['name'];
								$bDataOK = TRUE;
							}
						}
					}

					if(!$bDataOK) {
						$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.beview.unvalid');
					} else {
						$content .= $htmlTmpContent;
					}
					break;

				case 'Match->createTable':
					$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.table').' - ';
					$bDataOK = FALSE;
					if(!empty($aRowData['data']['sDEF']['lDEF']['settings.table.leagueSelection']['vDEF'])) {
						$aTeamdata = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('name','tx_sishandball2_domain_model_league','uid = '.intval($aRowData['data']['sDEF']['lDEF']['settings.table.leagueSelection']['vDEF']));
						if(!empty($aTeamdata['name'])) {
							$htmlTmpContent .= $aTeamdata['name'];
							$bDataOK = TRUE;
						}
					}

					if(!$bDataOK) {
						$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.beview.unvalid');
					} else {
						$content .= $htmlTmpContent;
					}
					break;

				case 'Match->createCrossTable':
					$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.pi_flexform.crosstable').' - ';
					$bDataOK = FALSE;
					if(!empty($aRowData['data']['sDEF']['lDEF']['settings.crosstable.leagueSelection']['vDEF'])) {
						$aTeamdata = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('name','tx_sishandball2_domain_model_league','uid = '.intval($aRowData['data']['sDEF']['lDEF']['settings.crosstable.leagueSelection']['vDEF']));
						if(!empty($aTeamdata['name'])) {
							$htmlTmpContent .= $aTeamdata['name'];
							$bDataOK = TRUE;
						}
					}

					if(!$bDataOK) {
						$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.beview.unvalid');
					} else {
						$content .= $htmlTmpContent;
					}
					break;

				default:
					$content .= $GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang_flexform.xml:sishandball.beview.unvalid');
					break;
			}
		}

		return $content;
	}
}
?>