<?php
namespace Thombo\Sishandball2\Helper;

/***************************************************************
*  Copyright notice
*
*  (c) 2016 Thomas Bodenbender <info@thombo.com>
*  thombo Softwareentwicklung und IT-Beratungs GmbH
*
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class Flexformutils {
    
        protected $flexFormData;
        protected $params;

	public function user_setTeams(&$params){
            $this->params = $params;

            $iLeagueID = 0;
            if($this->getFlexValue('settings.teammatches.leagueSelection') != '' && intval($this->getFlexValue('settings.teammatches.leagueSelection')) != 0){
                $iLeagueID = intval($this->getFlexValue('settings.teammatches.leagueSelection'));
            } elseif($this->getFlexValue('settings.leaguematches.leagueSelection') != '' && intval($this->getFlexValue('settings.leaguematches.leagueSelection')) != 0){
                $iLeagueID = intval($this->getFlexValue('settings.leaguematches.leagueSelection'));
            } elseif($this->getFlexValue('settings.table.leagueSelection') != '' && intval($this->getFlexValue('settings.table.leagueSelection')) != 0){
                $iLeagueID = intval($this->getFlexValue('settings.table.leagueSelection'));
            } elseif($this->getFlexValue('settings.crosstable.leagueSelection') != '' && intval($this->getFlexValue('settings.crosstable.leagueSelection')) != 0){
                $iLeagueID = intval($this->getFlexValue('settings.crosstable.leagueSelection'));
            }

            $dbTeams = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid','tx_sishandball2_domain_model_team ','league = '.intval($iLeagueID).' AND pid = '.intval($this->getFlexValue('settings.pages')));

            $uidList = '';
            while($teamData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($dbTeams)){
                if(!empty($uidList)){
                        $uidList .= ',';
                }

                $uidList .= $teamData['uid'];
            }

            $returnParams = array();
            foreach($params['items'] as $teamData){
                if(\TYPO3\CMS\Core\Utility\GeneralUtility::inList($uidList, $teamData[1]) || $teamData[1] == '' || $teamData[1] == '--div--'){
                    $returnParams[] = $teamData;
                }
            }

            $params['items'] = $returnParams;
	}

	public function user_setLeagues(&$params) {  
            $this->params = $params;

            $pages = intval($this->getFlexValue('settings.pages'));

            if(empty($pages)){
                $returnParams = array();
                foreach($params['items'] as $leagueData){
                        if($leagueData[1] == ''){
                                $leagueData[0] = \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('first', 'sishandball2');
                                $returnParams[] = $leagueData;
                        }
                }
                $params['items'] = $returnParams;
            } else {                        
                $dbLeagues = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid','tx_sishandball2_domain_model_league','pid = '.$pages);

                $uidList = '';
                while($leagueData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($dbLeagues)){
                        if(!empty($uidList)){
                                $uidList .= ',';
                        }

                        $uidList .= $leagueData['uid'];
                }

                $returnItems = array();
                foreach($params['items'] as $leagueData){
                        if(\TYPO3\CMS\Core\Utility\GeneralUtility::inList($uidList, $leagueData[1]) || $leagueData[1] == '' || $leagueData[1] == '--div--'){
                                $returnItems[] = $leagueData;
                        }
                }

                $params['items'] = $returnItems;
            }
	}

	public function user_setClubs(&$params){
            $this->params = $params;
            
            $pages = intval($this->getFlexValue('settings.pages'));

            if(empty($pages)){
                $returnParams = array();
                foreach($params['items'] as $clubData){
                    if($clubData[1] == '--div--'){
                        $clubData[0] = \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('first', 'sishandball2');
                        $returnParams[] = $clubData;
                    }
                }
                $aParams['items'] = $returnParams;
            } else {
                $dbClubs = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid','tx_sishandball2_domain_model_club ','pid = '.$pages);

                $uidList = '';
                while($dbClub = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($dbClubs)){
                    if(!empty($uidList)){
                        $uidList .= ',';
                    }

                    $uidList .= $dbClub['uid'];
                }

                $returnItems = array();
                foreach($params['items'] as $clubData){
                    if(\TYPO3\CMS\Core\Utility\GeneralUtility::inList($uidList, $clubData[1]) || $clubData[1] == '--div--'){
                            $returnItems[] = $clubData;
                    }
                }

                $params['items'] = $returnItems;
            }
	}

	public function user_setPrograms(&$params){
            $pagesList = '';

            $dbPages = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT pages.uid,pages.title','tx_sishandball2_domain_model_match,pages','tx_sishandball2_domain_model_match.pid = pages.uid');
            while($pageData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($dbPages)){
                if(!empty($pagesList)) {
                    $pagesList .= ',';
                }

                $pagesList .= $pageData['uid'];
            }


            $returnItems = array();
            foreach($params['items'] as $pageData){
                if(\TYPO3\CMS\Core\Utility\GeneralUtility::inList($pagesList, $pageData[1]) || ((empty($pageData[1]) || $pageData[1] == '--div--') && !empty($pagesList)) || ($pageData[1] == '-1' && empty($pagesList)) ) {
                    $returnItems[] = $pageData;
                }
            }

            $params['items'] = $returnItems;
	}

	public function processDatamap_preProcessFieldArray(&$incomingFieldArray, $table, $id, &$obj) {
            if(!empty($incomingFieldArray['list_type']) && $incomingFieldArray['list_type'] == 'sishandball2_sishandball2' && !empty($incomingFieldArray['pi_flexform'])){
                $aFlexform = $this->cleanArrayFlexform($incomingFieldArray['pi_flexform']);

                $objFlex = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\CMS\Core\Configuration\FlexForm\FlexFormTools');
                $xmlFlexform  = $objFlex->flexArray2Xml($aFlexform, true);

                $obj->overrideValues['tt_content']['pi_flexform'] = $xmlFlexform;
            }
	}

	protected function cleanArrayFlexform($flexFormData) {
            if(!empty($flexFormData['data']['sDEF']['lDEF']) && !empty($flexFormData['data']['sDEF']['lDEF']['settings.pages']['vDEF'])) {
                $sWhatToDisplay = $flexFormData['data']['sDEF']['lDEF']['switchableControllerActions']['vDEF'];

                $sDeletionKey = 'settings.';
                switch($sWhatToDisplay) {
                    case 'Match->matches4Team':
                        $sDeletionKey .= 'teammatches';
                        break;

                    case 'Match->matches4League':
                        $sDeletionKey .= 'leaguematches';
                        break;

                    case 'Match->matches4club':
                        $sDeletionKey .= 'clubmatches';
                        break;

                    case 'Match->createTable':
                        $sDeletionKey .= 'table';
                        break;

                    case 'Match->createCrossTable':
                        $sDeletionKey .= 'crosstable';
                        break;
                }

                foreach($flexFormData['data']['sDEF']['lDEF'] as $key => $value) {
                    if(!\TYPO3\CMS\Core\Utility\GeneralUtility::inList('switchableControllerActions,settings.pages',$key) && !\TYPO3\CMS\Core\Utility\GeneralUtility::isFirstPartOfStr($key, $sDeletionKey)) {
                        unset($flexFormData['data']['sDEF']['lDEF'][$key]);
                    }
                }
            } else if(empty($flexFormData['data']['sDEF']['lDEF']['settings.pages']['vDEF'])) {
                $flexFormData = array();
            }

            return $flexFormData;
	}
        
        protected function getFlexValue($key) {
            $value = '';
            if(\TYPO3\CMS\Core\Utility\GeneralUtility::compat_version('7.0')) {
                $value = $this->params['row'][$key];
            } else {
                if(empty($this->flexFormData)) {
                    $this->flexFormData = \TYPO3\CMS\Core\Utility\GeneralUtility::xml2array($this->params['row']['pi_flexform']);
                }

                $value = $this->flexFormData['data']['sDEF']['lDEF'][$key]['vDEF'];
            }
            
            if(is_array($value)) {
                $value = array_shift($value);
            }
            
            return $value;
        }
}