<?php
namespace Thombo\Sishandball2\Helper;

/***************************************************************
*  Copyright notice
*
*  (c) 2013 Thomas Bodenbender <info@thombo.com>,
*  thombo Softwareentwicklung und IT-Beratungs GmbH
*
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * Class 'RealUrl Configuration' for the 'sishandball2' extension.
 *
 * @author	Thomas Bodenbender <info@thombo.com>
 * @package	TYPO3
 * @subpackage	tx_sishandball2
 */
class Realurlconf {

	/**
	 * Generates additional RealURL configuration and merges it with provided configuration
	 *
	 * @param	array		$params	Default configuration
	 * @param	tx_realurl_autoconfgen		$pObj	Parent object
	 * @return	array		Updated configuration
	 */
	function addConfig($params, &$pObj) {
		$new = array(
			    'postVarSets' => array(
					'_DEFAULT' => array(
						'spielplan' => array(
							array(
								'GETvar' => 'tx_sishandball2_sishandball2[controller]',
								'valueMap' => array(
									'spiele' => 'Match'
								),
								'noMatch' => 'null'
							),
							array(
					      		'GETvar' => 'tx_sishandball2_sishandball2[page]'
					      	),
					    )
					)
				)
			);

		$params['config'] = array_merge_recursive($params['config'],$new);

		return $params['config'];
	}

}