<?php
namespace Thombo\Sishandball2\Update;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 Thomas Bodenbender <info@thombo.com>
 *  thombo Softwareentwicklung und IT-Beratungs GmbH
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * XMLData
 */
class XMLData {
	var $iPid;
	var $sPidString;
	var $hallsDB;
	var $teamsDB_act;
	var $teamsDB_handled;
	var $matchesDB_act;
	var $matchXML_act;
	var $leagueId_act;
	var $sisUsername;
	var $sisPassword;
	var $leagueids;
	var	$updatetime;
	var $hallpid;
	var $handledTeams;
	var $clubDB;
	var $bUpdate;

	var $bDebug;
	var $sLogstring;
	var $bErrorOcurred;
	var $aMatchUids = array();
	var $aMailFiles = array();

	var $_LOCAL_LANG = array();

	function __construct($lLeagueids = '',$iPid = 0, $bUpdate = false){
		$this->bErrorOcurred = FALSE;
		$this->bDebug = (bool)$GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['debugging'];

		if($this->bDebug) {
			$this->log('bigSpacer');
			$this->log('',"\n");
		}

		$this->init($lLeagueids,$iPid,$bUpdate);

		$rLeagues4Update = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,pid,number,tstamp,name,access','tx_sishandball2_domain_model_league','1 = 1'.$this->sPidString);

		while($aLeagueData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($rLeagues4Update)){
			$this->log('smallSpacer');

			if(empty($this->leagueids) || (!empty($this->leagueids) && \TYPO3\CMS\Core\Utility\GeneralUtility::inList($this->leagueids,$aLeagueData['uid']))) {

				if($this->bDebug) {
					$this->log('leagueUpdate',(string)$aLeagueData['name']);
					$this->log('',"\n");
				}

				$this->updateLeague($aLeagueData);

			} else {

				if($this->bDebug) {
					$this->log('leagueNoUpdate',(string)$aLeagueData['name']);
					$this->log('updateLeagueIds',(string)$this->leagueids);
					$this->log('actLeagueId',(string)$aLeagueData['uid']);
				}

			}

			if($this->bDebug) {

				$this->log('',"\n");
				$this->log('leagueUpdateEnd',(string)$aLeagueData['name']);
				$this->log('smallSpacer');
				$this->log('',"\n\n");

			}
		}

		if($this->bDebug) {
			$this->log('bigSpacer');
		}

		if($this->bDebug && \TYPO3\CMS\Core\Utility\GeneralUtility::validEmail($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['email']) && $this->bErrorOcurred) {

			$objMail = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('t3lib_htmlmail');
			$objMail->start();

			$objMail->from_name = $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['email_sendername'];
			$objMail->from_email = $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['email_sender'];

			$objMail->setRecipient($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['email']);
			$objMail->subject = 'XML Updatereport';

			$objMail->addPlain($this->sLogstring);

			foreach($this->aMailFiles as $sFileName => $sFileContent) {
				if(FALSE !== @file_put_contents(PATH_site.'uploads/tx_sishandball/'.$sFileName,$sFileContent)) {
					$objMail->addAttachment(PATH_site.'uploads/tx_sishandball/'.$sFileName);
				}
			}

			$objMail->setHeaders();
			$objMail->setContent();

			$objMail->sendTheMail();

			foreach($this->aMailFiles as $sFileName => $sFileContent) {
				@unlink(PATH_site.'uploads/tx_sishandball/'.$sFileName);
			}

		}
	}

	private function init($lLeagueids = '',$iPid = 0, $bUpdate = false) {
		if(empty($iPid)) {
			// wenn eine pid in den url-aparametern �bergeben
			$this->iPid = intval(\TYPO3\CMS\Core\Utility\GeneralUtility::_GET('pid'));
		} else {
			$this->iPid = intval($iPid);
		}

		if(!empty($this->iPid)){
			$this->sPidString = ' AND pid = '.$this->iPid;
		} else {
			$this->sPidString = '';
		}

		if($this->bDebug) {
			$this->log('setPid',(string)$this->iPid);
			$this->log('',"\n");
		}

		/**
		* $this->leagueids contains a list of id, given by the GET-parameter "leagueids"
		*/
		if(empty($lLeagueids)) {
			$this->leagueids = \TYPO3\CMS\Core\Utility\GeneralUtility::_GET('leagueids');
		} else {
			$this->leagueids = $lLeagueids;
		}

		if($this->bDebug) {
			$this->log('setLeagueIds',(string)$this->leagueids);
			$this->log('',"\n");
		}

		if(!$bUpdate) {
			$this->bUpdate = (bool)intval(\TYPO3\CMS\Core\Utility\GeneralUtility::_GET('update'));
		} else {
			$this->bUpdate = (bool)$bUpdate;
		}

		/**
		* Hilfsarray mit den Identifikationsdaten der Sporthallen
		* array('1410301104' => '1', ...);
		* array('[sisnummer]' => '[typo3sportshalluid]', ...);
		*/
		$this->hallsDB = array();
		$this->hallpid = 0;
		$halls = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,number,pid','tx_sishandball2_domain_model_sportshall','1 = 1');
		while($hall = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($halls)){
			$this->hallsDB[$hall['number']] = $hall['uid'];
			if(intval($this->hallpid) == 0) $this->hallpid = $hall['pid'];
		}

		if(intval($this->hallpid) == 0) {
			$this->hallpid = $this->iPid;
		}

		if($this->bDebug) {
			$this->log('setHallPid',(string)$this->hallpid);
			$this->log('',"\n");
			$this->aMailFiles['sporthallsDB.txt'] = print_r($this->hallsDB,true);
		}

		/**
		 * Hilfsarray mit den Identifikationsdaten der Vereine
		 * array('1410201110' => 1, ...);
		 * array('[sisnummer]' => [typo3clubuid]', ...);
		 */
		$this->clubDB = array();
		$clubs = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,number','tx_sishandball2_domain_model_club','1=1'.$this->sPidString);
		while($club = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($clubs)){
			$this->clubDB[$club['number']] = $club['uid'];
		}

		if($this->bDebug) {
			$this->aMailFiles['clubsDB.txt'] = str_replace("\n","\n\r",print_r($this->clubDB,true));
		}

		/**
		* $this->updatetime contains a unixtimestamp
		*/
		$this->updatetime = time();
	}

	private function updateLeague($aLeagueData){
		$this->leagueId_act = $aLeagueData['uid'];

		if(empty($this->iPid)) {
			$this->iPid = intval($aLeagueData['pid']);
		}

		/** Daten der bereits gespeicherten Mannschaften der aktuellen Liga auslesen
		* $this->teamsDB_act:
		* array('001508504501401000000000000000000002009' => array('tstamp' => '1190711974', 'uid' => 1, 'pid' => 171);
		* array('[sisnummer]' => array('tstamp' => '[typo3tstamp]', 'uid' => [typo3uid], 'pid' => [typo3pid]);
		*/
		$this->teamsDB_act = array();
		$leagueteams = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,pid,tstamp,number','tx_sishandball2_domain_model_team','league = '.$aLeagueData['uid'].$this->sPidString);
		while($team = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($leagueteams)){
			$this->teamsDB_act[$team['number']] = array('tstamp' => $team['tstamp'], 'uid' => $team['uid'], 'pid' => $team['pid']);
		}
		$this->teamsDB_handled = $this->teamsDB_act;

		if($this->bDebug) {
			$this->aMailFiles['teamsDB.'.$this->leagueId_act.'.txt'] = str_replace("\n","\n\r",print_r($this->teamsDB_handled,true));
		}

		/** Daten der bereits gespeicherten Spiele der aktuellen Liga auslesen
		* $this->matchesDB_act:
		* array('001509504501401000000000000000000002004' => '1221334831', '001509504501401000000000000000000002004_pid' => '280', '001509504501401000000000000000000002004_uid' => '538');
		*/
		$this->matchesDB_act = array();
		$leaguematches = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,number,tstamp,pid','tx_sishandball2_domain_model_match','league = '.$aLeagueData['uid'].$this->sPidString);
		while($leaguematch = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($leaguematches)){
			$this->matchesDB_act[substr($aLeagueData['number'],0,36).str_pad($leaguematch['number'],3,'0',STR_PAD_LEFT)] = $leaguematch['tstamp'];
			$this->matchesDB_act[substr($aLeagueData['number'],0,36).str_pad($leaguematch['number'],3,'0',STR_PAD_LEFT).'_pid'] = $leaguematch['pid'];
			$this->matchesDB_act[substr($aLeagueData['number'],0,36).str_pad($leaguematch['number'],3,'0',STR_PAD_LEFT).'_uid'] = $leaguematch['uid'];
		}

		if($this->bDebug) {
			$this->aMailFiles['matchesDB.'.$this->leagueId_act.'.txt'] = str_replace("\n","\n\r",print_r($this->matchesDB_act,true));
		}

		$iArt = 1;
		if($this->bUpdate) {
			$iArt = 3;
		}

		if(!empty($aLeagueData['access'])) {
			$rAccessData = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username,password','tx_sishandball2_domain_model_access','uid = '.intval($aLeagueData['access']));
			$aAccessData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($rAccessData);

			if(!empty($aAccessData)) {
				$sDomainEnding = 'de';
				if(\TYPO3\CMS\Core\Utility\GeneralUtility::isFirstPartOfStr($aLeagueData['number'], '002')) {
					$sDomainEnding = 'at';
				}
				// XML online abrufen
				$xmlcontent = @file_get_contents('http://www.sis-handball.'.$sDomainEnding.'/xmlexport/xml_dyn.aspx?art='.$iArt.'&auf='.$aLeagueData['number'].'&user='.$aAccessData['username'].'&pass='.$aAccessData['password']);

				if(!empty($xmlcontent)){
					if($this->bDebug) {
						$this->aMailFiles['sisData.'.$this->leagueId_act.'.xml'] = $xmlcontent;
					}

					$doc = new \DOMDocument('1.0','utf-8');
					if($doc->loadXML($xmlcontent)){
						$matches = $doc->getElementsByTagName('Spiel');

						if($matches->length == 0) return;

						// durchlaufe alle Spiel-Knoten des XML-Dokuments
						for ($i = 0; $i < $matches->length; $i++) {
							$this->matchXML_act = array();
							// durchlaufe alle Attribute des aktuellen Spiel-Knotens
							for($j=0; $j<$matches->item($i)->childNodes->length; $j++){
								$this->matchXML_act[$matches->item($i)->childNodes->item($j)->nodeName] = $matches->item($i)->childNodes->item($j)->nodeValue;
								if($matches->item($i)->childNodes->item($j)->nodeName == 'Liga') {
									$sXmlMatchNo = (string)$matches->item($i)->childNodes->item($j)->nodeValue;
									$sUpdLeagueNo = (string)$aLeagueData['number'];

									if(substr($sXmlMatchNo,0,36) !== substr($sUpdLeagueNo,0,36)){
									   	if($this->bDebug){
									   		$this->log('badXML');
									   		$this->log('',"\n");
									   		$this->bErrorOcurred = TRUE;
									   	}
										return;
									}
								}
							}

							if($this->bDebug) {
								$this->log('match',(string)$this->matchXML_act['Liga']);
							}

							if(!empty($this->matchesDB_act[$this->matchXML_act['Liga']])){
								if(strtotime($this->matchXML_act['Aktualisierungsdatum']) > $this->matchesDB_act[$this->matchXML_act['Liga']]){
									if($this->bDebug) {
										$this->log('matchUpdate',(string)$league['name']);
									}
									$this->updateMatch();
								} else {
									(!empty($this->teamsDB_act[$this->matchXML_act['Mannschaft1']])?$this->updateTeam('1'):$this->insertTeam('1'));
									(!empty($this->teamsDB_act[$this->matchXML_act['Mannschaft2']])?$this->updateTeam('2'):$this->insertTeam('2'));
								}
							} else {
								$this->insertMatch();
							}

							unset($this->matchesDB_act[$this->matchXML_act['Liga']],
								  $this->matchesDB_act[$this->matchXML_act['Liga'].'_pid'],
								  $this->matchesDB_act[$this->matchXML_act['Liga'].'_uid']);
						}

						if($iArt == 1) {
							foreach($this->matchesDB_act as $iMatchId => $aValues){
								if(!ctype_digit($iMatchId) && substr($iMatchId,strlen($iMatchId)-4) == '_uid'){
									$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_sishandball2_domain_model_match','number LIKE \''.intval(substr($iMatchId,36,3)).'\'');
									if($this->bDebug) {
										$this->log('matchDelete',(string)substr($iMatchId,36,3),(string)print_r($aValues,TRUE));
										$this->bErrorOcurred = TRUE;
									}
								}
							}

							foreach($this->teamsDB_handled as $iTeamId => $aValues){
								if(ctype_digit($iTeamId)){
									$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_sishandball2_domain_model_team','number LIKE \''.$iTeamId.'\'');
									if($this->bDebug) {
										$this->log('teamDelete',$iTeamId,print_r($aValues,TRUE));
										$this->bErrorOcurred = TRUE;
									}
								}
							}
						}
					}

					$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_sishandball2_domain_model_league','uid = '.intval($aLeagueData['uid']),array('tstamp' => $this->updatetime));
				}
			}
		}
	}

	private function updateMatch(){
		$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_sishandball2_domain_model_match',
		                                       '`uid` = '.$this->matchesDB_act[$this->matchXML_act['Liga'].'_uid'].' AND
		                                        `tstamp` != '.strtotime($this->matchXML_act['Aktualisierungsdatum']),
		                                       $this->getMatchFieldArray());

		if($GLOBALS['TYPO3_DB']->sql_affected_rows() == 1) {
			if(!in_array($this->matchesDB_act[$this->matchXML_act['Liga'].'_uid'],$this->aMatchUids)) {
				$this->aMatchUids[] = $this->matchesDB_act[$this->matchXML_act['Liga'].'_uid'];
			}
		}

		if($this->bDebug) {
			$this->log('matchUpdate',(string)$this->matchesDB_act[$this->matchXML_act['Liga'].'_uid']);
		}
	}

	private function insertMatch(){
		$fieldstmp = $this->getMatchFieldArray();
		$fieldstmp['crdate'] = $fieldstmp['tstamp'];

		$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sishandball2_domain_model_match',$fieldstmp);
		if($this->bDebug) {
			$this->log('newMatch',(string)$GLOBALS['TYPO3_DB']->sql_insert_id());
		}
	}

	private function getMatchFieldArray(){
		$fields = array();
		$fields['pid']        = (!empty($this->iPid)?$this->iPid:intval($this->matchesDB_act[$this->matchXML_act['Liga'].'_pid']));
		$fields['tstamp']     = strtotime($this->matchXML_act['Aktualisierungsdatum']);
		$fields['league']     = $this->leagueId_act;
		$fields['number']     = intval(substr($this->matchXML_act['Liga'],36,3));
		$fields['matchdate']       = strtotime($this->matchXML_act['SpielVon']);
		$fields['hall']       = (!empty($this->hallsDB[$this->matchXML_act['Halle']])?intval($this->hallsDB[$this->matchXML_act['Halle']]):$this->insertHall());
		$fields['home']       = (!empty($this->teamsDB_act[$this->matchXML_act['Mannschaft1']])?$this->updateTeam('1'):$this->insertTeam('1'));
		$fields['guest']      = (!empty($this->teamsDB_act[$this->matchXML_act['Mannschaft2']])?$this->updateTeam('2'):$this->insertTeam('2'));
		$fields['rslt_hlf_h'] = $this->matchXML_act['Tore01'];
		$fields['rslt_hlf_g'] = $this->matchXML_act['Tore02'];
		$fields['rslt_h']     = $this->matchXML_act['Tore1'];
		$fields['rslt_g']     = $this->matchXML_act['Tore2'];
		$fields['pts_h']      = $this->matchXML_act['Punkte1'];
		$fields['pts_g']      = $this->matchXML_act['Punkte2'];

		return $fields;
	}

	private function insertHall(){
		$fields = array();
		$fields['pid']    = (!empty($this->hallpid)?$this->hallpid:(!empty($this->iPid)?$this->iPid:intval($this->matchesDB_act[$this->matchXML_act['Liga'].'_pid'])));
		$fields['crdate'] = strtotime($this->matchXML_act['Aktualisierungsdatum']);
		$fields['tstamp'] = strtotime($this->matchXML_act['Aktualisierungsdatum']);
		$fields['number'] = $this->matchXML_act['Halle'];
		$fields['name']   = $this->matchXML_act['HallenName'];
		$fields['street'] = $this->matchXML_act['HallenStrasse'];
		$fields['city']   = $this->matchXML_act['HallenOrt'];

		if((bool)$GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['utf8']){
			$fields['name']   = utf8_decode($this->matchXML_act['HallenName']);
			$fields['street'] = utf8_decode($this->matchXML_act['HallenStrasse']);
			$fields['city']   = utf8_decode($this->matchXML_act['HallenOrt']);
		}

		$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sishandball2_domain_model_sportshall',$fields);

		$this->hallsDB[$fields['number']] = $GLOBALS['TYPO3_DB']->sql_insert_id();

		if($this->bDebug) {
			$this->log('newHall',(string)$this->hallsDB[$fields['number']],$fields['number']);
		}

		return $this->hallsDB[$fields['number']];
	}

	private function updateTeam($teamnumberxml){
		if(!\TYPO3\CMS\Core\Utility\GeneralUtility::inList(rtrim($this->handledTeams,','),$this->matchXML_act['Mannschaft'.intval($teamnumberxml)])){
			$fields = $this->getTeamFieldArray($teamnumberxml);
			if($this->bDebug) {
				$this->log('teamUpdate',(string)$this->teamsDB_act[$this->matchXML_act['Mannschaft'.intval($teamnumberxml)]]['uid'],$fields['name']);
			}

			unset($fields['name']);
			$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_sishandball2_domain_model_team','uid = '.intval($this->teamsDB_act[$this->matchXML_act['Mannschaft'.intval($teamnumberxml)]]['uid']),$fields);
			unset($this->teamsDB_handled[$this->matchXML_act['Mannschaft'.intval($teamnumberxml)]]);

			$this->handledTeams .= $this->matchXML_act['Mannschaft'.intval($teamnumberxml)].',';
		}

		return intval($this->teamsDB_act[$this->matchXML_act['Mannschaft'.intval($teamnumberxml)]]['uid']);
	}

	private function insertTeam($teamnumberxml){
		$fieldstmp = $this->getTeamFieldArray(intval($teamnumberxml));
		$fieldstmp['crdate'] = $fieldstmp['tstamp'];

		$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sishandball2_domain_model_team',$fieldstmp);

		$this->teamsDB_act[$fieldstmp['number']]['uid']    = $GLOBALS['TYPO3_DB']->sql_insert_id();
		$this->teamsDB_act[$fieldstmp['number']]['tstamp'] = $fieldstmp['tstamp'];
		$this->teamsDB_act[$fieldstmp['number']]['pid']    = $fieldstmp['pid'];

		if($this->bDebug) {
			$this->log('newTeam',(string)$this->teamsDB_act[$fieldstmp['number']]['uid'],$fieldstmp['name']);
		}

		return 	$this->teamsDB_act[$fieldstmp['number']]['uid'];
	}

	private function getTeamFieldArray($teamnumberxml){
		$fields = array();
		$fields['pid']     = (!empty($this->iPid)?$this->iPid:intval($this->matchesDB_act[$this->matchXML_act['Liga'].'_pid']));
		$fields['tstamp']  = strtotime($this->matchXML_act['Aktualisierungsdatum']);
		$fields['number']  = $this->matchXML_act['Mannschaft'.$teamnumberxml];
		$fields['name']    = ($teamnumberxml == 1?$this->matchXML_act['Heim']:$this->matchXML_act['Gast']);
		$fields['sisname'] = ($teamnumberxml == 1?$this->matchXML_act['Heim']:$this->matchXML_act['Gast']);
		$fields['league']  = $this->leagueId_act;

		$clubno = ($teamnumberxml == 1?$this->matchXML_act['HeimNr']:$this->matchXML_act['GastNr']);
		if(!empty($this->clubDB[$clubno])) {
			$fields['club'] = intval($this->clubDB[$clubno]);
		} else {
			$fields['club'] = $this->insertClub($teamnumberxml);
		}

		if((bool)$GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['utf8']){
			$fields['name']    = utf8_decode(($teamnumberxml == 1?$this->matchXML_act['Heim']:$this->matchXML_act['Gast']));
			$fields['sisname'] = utf8_decode(($teamnumberxml == 1?$this->matchXML_act['Heim']:$this->matchXML_act['Gast']));
		}

		return $fields;
	}

	private function insertClub($teamnumberxml){
		$fields = array();
		$fields['pid']    = (!empty($this->iPid)?$this->iPid:intval($this->matchesDB_act[$this->matchXML_act['Liga'].'_pid']));
		$fields['tstamp'] = strtotime($this->matchXML_act['Aktualisierungsdatum']);
		$fields['crdate'] = strtotime($this->matchXML_act['Aktualisierungsdatum']);
		$fields['number'] = ($teamnumberxml == 1?$this->matchXML_act['HeimNr']:$this->matchXML_act['GastNr']);
		$fields['name']   = ($teamnumberxml == 1?$this->matchXML_act['Heim']:$this->matchXML_act['Gast']);

		if((bool)$GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['sishandball']['utf8']){
			$fields['name']   = utf8_decode(($teamnumberxml == 1?$this->matchXML_act['Heim']:$this->matchXML_act['Gast']));
		}

		$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sishandball2_domain_model_club',$fields);

		$this->clubDB[$fields['number']] = $GLOBALS['TYPO3_DB']->sql_insert_id();

		if($this->bDebug) {
			$this->log('newClub',(string)$this->clubDB[$fields['number']],$fields['number']);
		}

		return $this->clubDB[$fields['number']];
	}

	private function log($sLVarKey,$sInput1 = '',$sInput2 = '') {
		$sLVar = \TYPO3\CMS\Extbase\Utility\LocalizationUtility::translate('xmlUpdate.'.$sLVarKey, 'sishandball2');

		if(!empty($sLVar)) {
			if(!empty($sInput1)) {
				if(!empty($sInput2)) {
					$this->sLogstring .= sprintf($sLVar,(string)$sInput1,(string)$sInput2);
				} else{
					$this->sLogstring .= sprintf($sLVar,(string)$sInput1);
				}
			} else {
				$this->sLogstring .= $sLVar;
			}
		} else {
			if(!empty($sInput)) {
				$this->sLogstring .= $sInput;
			}
		}
		$this->sLogstring .= "\n";
	}
}