<?php
namespace Thombo\Sishandball2\ViewHelpers\Link;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Thomas Bodenbender <info@thombo.com>, 
 *  thombo Softwareentwicklung und IT-Beratungs GmbH
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * EditMatchViewHelper
 */
class EditMatchViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractTagBasedViewHelper {

	/**
	 * @var string
	 */
	protected $tagName = 'a';

	/**
	 * @param \integer $shopUid shopUid
	 * @return string Rendered link
	 */
	public function render($matchUid) {               
                $onClick = \TYPO3\CMS\Backend\Utility\BackendUtility::editOnClick('&edit[tx_sishandball2_domain_model_match]['.$matchUid.']=edit');
                   
                $iconCode = '';
                if(\TYPO3\CMS\Core\Utility\GeneralUtility::compat_version('7.0')) {
                    $iconFactory = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconFactory::class);
                    $iconCode = $iconFactory->getIcon('actions-document-open', \TYPO3\CMS\Core\Imaging\Icon::SIZE_SMALL);
                } else {
                    $iconCode = \TYPO3\CMS\Backend\Utility\IconUtility::getSpriteIcon('actions-document-open');
                }

		$this->tag->addAttribute('href', '#');
                $this->tag->addAttribute('onclick', $onClick);
		$this->tag->setContent($iconCode);
		$this->tag->forceClosingTag(TRUE);
		return $this->tag->render();
	}

}