<?php
namespace Thombo\Sishandball2\ViewHelpers;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2015 Thomas Bodenbender <info@thombo.com>, thombo Softwareentwicklung und IT-Beratungs GmbH
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * TeamShortViewHelper
 */
class TeamShortViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper {

	/**
	 * @param \TYPO3\CMS\Extbase\Persistence\QueryResultInterface $teams teams
	 * @param \Thombo\Sishandball2\Domain\Model\Team $home
	 * @param \Thombo\Sishandball2\Domain\Model\Team $guest
	 * @return string Rendered Short
	 */
	public function render(\TYPO3\CMS\Extbase\Persistence\QueryResultInterface $teams, \Thombo\Sishandball2\Domain\Model\Team $home, \Thombo\Sishandball2\Domain\Model\Team $guest) {
		foreach($teams as $team) {
			if($team->getTeam() == $home || $team->getTeam() == $guest) {
				return $team->getShortdescription();
			}
		}
	}

}