<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 Thomas Bodenbender <info@thombo.com>, 
 *  thombo Softwareentwicklung und IT-Beratungs GmbH
 * 
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * @author	Thomas Bodenbender <info@thombo.com>
 * @package	TYPO3
 * @subpackage	tx_sishandball2
 */
class ext_update {
	var $aUpdatedLeagues = array();

	function main() {
		$htmlUpdateContent = '';
		$htmlCleanContent = '';

		if(empty($_POST['page'])) {
			$htmlUpdateContent .= '<select name="page" onchange="javascript:this.form.submit();"><option value="0">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.chooseprogram').'</option>';
			$rProgramPages = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT pages.uid,
	                                                                 pages.title',
			                                                        'pages,
	                                                                 tx_sishandball2_domain_model_league',
			                                                        'tx_sishandball2_domain_model_league.pid = pages.uid AND
	                                                                 NOT pages.deleted AND
	                                                                 NOT pages.hidden');

			while($aProgramPageData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($rProgramPages)) {
				$htmlUpdateContent .= '<option value="'.$aProgramPageData['uid'].'">'.$aProgramPageData['title'].'</option>';
			}
			$htmlUpdateContent .= '</select>';
		} else {
			if(!empty($_POST['leagues'])) {
				$this->updateLeagues();
			}

			$aProgramPageData = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('title','pages','uid = '.intval($_POST['page']));

			$sProgramPageLabel = sprintf($GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.programpagelabel'),$aProgramPageData['title']);

			$htmlUpdateContent .= '<h4>'.$sProgramPageLabel.'<a href="'.\TYPO3\CMS\Core\Utility\GeneralUtility::linkThisScript().'" style="margin-left: 10px;"><img src="../typo3conf/ext/sishandball2/Resources/Public/Icons/cancel.png" width="16" height="16" /></a></h4>';
			$htmlUpdateContent .= '<p style="font-size: 80%">['.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.lastupdate').']</p>';

			$rLeagues = $GLOBALS['TYPO3_DB']->exec_SELECTquery('tx_sishandball2_domain_model_league.uid,
                                                                tx_sishandball2_domain_model_league.name',
			                                                   'tx_sishandball2_domain_model_league',
                                                               'tx_sishandball2_domain_model_league.pid = '.intval($_POST['page']));

			while($aLeagues = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($rLeagues)) {
				$htmlUpdated = '';
				if(in_array($aLeagues['uid'],$this->aUpdatedLeagues)) {
					$htmlUpdated = ' <span style="color: green;">('.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.updated').')</span>';
				}

				$htmlUpdateTime = '';
				$aMatchUpdates = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('min(tx_sishandball2_domain_model_match.tstamp) as tstamp','tx_sishandball2_domain_model_match','tx_sishandball2_domain_model_match.league = '.intval($aLeagues['uid']));
				if(!empty($aMatchUpdates[0]['tstamp'])) {
					$htmlUpdateTime = '['.strftime('%d.%m.%Y, %H:%M Uhr',$aMatchUpdates['tstamp']).'] ';
				}

				$htmlUpdateContent .= '<p style="margin: 0; padding-bottom: 0;"><input type="checkbox" name="leagues[]" value="'.$aLeagues['uid'].'" /> '.$htmlUpdateTime.$aLeagues['name'].$htmlUpdated.'</p>';
			}

			$htmlUpdateContent .= '<input type="checkbox" name="update" value="1" /> '.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.onlysmallupdate').'<br /><input type="hidden" name="page" value="'.intval($_POST['page']).'" /><span class="spinner" style="display: none; width: 200px; background-repeat: no-repeat; padding-left: 20px; margin-bottom: 10px; margin-top: 10px;" id="spinner">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.updateruns').'</span><input type="submit" id="leagueupdatesubmit" value="'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.doupdate').'" onclick="document.getElementById(\'leagueupdatesubmit\').setAttribute(\'disabled\',\'disabled\'); document.getElementById(\'spinner\').style.display=\'block\';this.form.submit();" />';
		}

		if(empty($_POST['cleanPage'])) {
			$htmlCleanContent .= '<select name="cleanPage" onchange="javascript:this.form.submit();"><option value="0">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.chooseprogram').'</option>';
			$rProgramPages = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT pages.uid,
	                                                                 pages.title',
																	'pages,
	                                                                 tx_sishandball2_domain_model_league',
																	'tx_sishandball2_domain_model_league.pid = pages.uid AND
	                                                                 NOT pages.deleted AND
	                                                                 NOT pages.hidden');

			while($aProgramPageData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($rProgramPages)) {
				$htmlCleanContent .= '<option value="'.$aProgramPageData['uid'].'">'.$aProgramPageData['title'].'</option>';
			}
			$htmlCleanContent .= '</select>';
		} else {
			if(!empty($_POST['leagues_clean'])) {
				$this->cleanLeagues();
			}

			$aProgramPageData = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('title','pages','uid = '.intval($_POST['cleanPage']));

			$sProgramPageLabel = sprintf($GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.programpagelabel'),$aProgramPageData[0]['title']);

			$htmlCleanContent .= '<h4>'.$sProgramPageLabel.'<a href="'.\TYPO3\CMS\Core\Utility\GeneralUtility::linkThisScript().'" style="margin-left: 10px;"><img src="../typo3conf/ext/sishandball2/Resources/Public/Icons/cancel.png" width="16" height="16" /></a></h4>';
			$htmlCleanContent .= '<p style="font-size: 80%">['.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.lastupdate').']</p>';

			$rLeagues = $GLOBALS['TYPO3_DB']->exec_SELECTquery('tx_sishandball2_domain_model_league.uid,
                                                                tx_sishandball2_domain_model_league.name',
															   'tx_sishandball2_domain_model_league',
															   'tx_sishandball2_domain_model_league.pid = '.intval($_POST['cleanPage']));

			while($aLeagues = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($rLeagues)) {
				$htmlCleaned = '';
				if(key_exists($aLeagues['uid'],$this->aCleanedLeagues)) {
					$htmlCleaned = ' <span style="color: green;">('.sprintf($GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.cleanedTeams'),intval($this->aCleanedLeagues[intval($aLeagues['uid'])]['cleanedTeamsCount'])).sprintf($GLOBALS['LANG']->sL('LLL:EXT:sishandball/locallang.xlf:extupdate.cleanedMatches'),intval($this->aCleanedLeagues[intval($aLeagues['uid'])]['cleanedMatchesCount'])).')</span>';
				}

				$htmlUpdateTime = '';
				$aMatchUpdates = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('min(tx_sishandball2_domain_model_match.tstamp) as tstamp','tx_sishandball2_domain_model_match','tx_sishandball2_domain_model_match.league = '.intval($aLeagues['uid']));
				if(!empty($aMatchUpdates['tstamp'])) {
					$htmlUpdateTime = '['.strftime('%d.%m.%Y, %H:%M Uhr',$aMatchUpdates['tstamp']).'] ';
				}

				$htmlCleanContent .= '<p style="margin: 0; padding-bottom: 0;"><input type="checkbox" name="leagues_clean[]" value="'.$aLeagues['uid'].'" /> '.$htmlUpdateTime.$aLeagues['name'].$htmlCleaned.'</p>';
			}

			$htmlCleanContent .= '<input type="hidden" name="cleanPage" value="'.intval($_POST['cleanPage']).'" /><span class="spinner" style="display: none; width: 200px; background-repeat: no-repeat; padding-left: 20px; margin-bottom: 10px; margin-top: 10px;" id="spinner">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.updateruns').'</span><input type="submit" id="leaguecleanupsubmit" value="'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.doupdate').'" onclick="document.getElementById(\'leaguecleanupsubmit\').setAttribute(\'disabled\', \'disabled\'); document.getElementById(\'spinner\').style.display=\'block\';this.form.submit();" />';
		}

		return '<form method="post" action="">'.$htmlUpdateContent.'</form>'.$this->sCleanMessage.$this->getHelpContainer().'<br /><br /><form method="post" action=""><h3 class="uppercase">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.cleantopic').'</h3>'.$htmlCleanContent.'</form>'.$this->getHelpContainerClean();
	}

	function updateLeagues() {
		$lLeagueIds = '';
		foreach($_POST['leagues'] as $iLeagueId) {
			if(!empty($lLeagueIds)) {
				$lLeagueIds .= ',';
			}
			$lLeagueIds .= $iLeagueId;
			$this->aUpdatedLeagues[] = intval($iLeagueId);
		}

		\TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('Thombo\Sishandball2\Update\XMLData', $lLeagueIds, intval($_POST['page']), intval($_POST['update']));
	}

	function cleanLeagues(){
		foreach($_POST['leagues_clean'] as $iLeagueId) {
			if(!empty($iLeagueId)) {
				$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_sishandball2_domain_model_team','league = '.intval($iLeagueId));
				$this->aCleanedLeagues[intval($iLeagueId)]['cleanedTeamsCount'] = $GLOBALS['TYPO3_DB']->sql_affected_rows();

				$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_sishandball2_domain_model_match','league = '.intval($iLeagueId));
				$this->aCleanedLeagues[intval($iLeagueId)]['cleanedMatchesCount'] = $GLOBALS['TYPO3_DB']->sql_affected_rows();
			}
		}
	}

	function getHelpContainer() {
		$htmlContent = '';
		$htmlContent .= '<br /><br />';
		$htmlContent .= '<h3 class="uppercase" style="color: #970000;">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.helptopic').'</h3>';
		$htmlContent .= '<img src="../typo3conf/ext/sishandball2/Resources/Public/Icons/information.png" style="float: left;" />';
		$htmlContent .= '<div style="margin-top: 10px; margin-left: 25px;">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.helptext').'</div>';

		return $htmlContent;
	}

	function getHelpContainerClean() {
		$htmlContent = '';
		$htmlContent .= '<br /><br />';
		$htmlContent .= '<h3 class="uppercase" style="color: #970000;">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.helpcleantopic').'</h3>';
		$htmlContent .= '<img src="../typo3conf/ext/sishandball2/Resources/Public/Icons/information.png" style="float: left;" />';
		$htmlContent .= '<div style="margin-top: 10px; margin-left: 25px;">'.$GLOBALS['LANG']->sL('LLL:EXT:sishandball2/Resources/Private/Language/locallang.xlf:extupdate.helpcleantext').'</div>';

		return $htmlContent;
	}

	function access() {
		return TRUE;
	}
}
?>